require "ey/logger/version"

require "awesome_print"
require "json"

require "logger"

module Ey
  class Logger

    attr_reader :device, :formatter, :default_level, :prefix

    def initialize(options={})
      @device        = options.fetch(:device)
      @default_level = options[:default_level]  || :info
      @prefix        = options[:prefix] || nil
      @formatter     = Ey::Logger::Formatter.for(options[:format] || :human).new(prefix)
    end

    def call(options)
      level = options[:level] || default_level
      output = formatter.call(options.fetch(:tag), options.fetch(:data))

      device.public_send(level, output)
    end
  end
end

require 'ey/logger/formatter'
require 'ey/logger/machine_parser'

require 'ey/logger/faraday'
