class Ey::Logger::Formatter
  def self.types
    @@types ||= {}
  end

  def self.for(type)
    types.fetch(type)
  end

  attr_reader :prefix

  def initialize(prefix)
    @prefix = prefix
  end

  def call(_tag, data)
    raise NotImplementedError
  end

  def tag_for(tag)
    [prefix, tag].compact.join(".")
  end
end

require 'ey/logger/machine_formatter'
require 'ey/logger/human_formatter'
